[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Annotation of openbsd/fw_update/fw_install.sh, Revision 1.104

1.1       afresh1     1: #!/bin/ksh
1.36      afresh1     2: #      $OpenBSD$
1.50      afresh1     3: #
1.38      afresh1     4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17:
1.95      afresh1    18: set -o errexit -o pipefail -o nounset -o noclobber -o noglob
1.85      afresh1    19: set +o monitor
1.77      afresh1    20: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50      afresh1    21:
                     22: CFILE=SHA256.sig
                     23: DESTDIR=${DESTDIR:-}
                     24: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                     25:
                     26: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
                     27: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
                     28:
                     29: HTTP_FWDIR="$VNAME"
1.52      afresh1    30: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
                     31:     /var/run/dmesg.boot | sed '$!d' )
1.50      afresh1    32: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22      afresh1    33:
1.50      afresh1    34: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
                     35: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8       afresh1    36:
1.97      afresh1    37: VERBOSE=false
1.87      afresh1    38: DOWNLOAD=true
                     39: INSTALL=true
1.69      afresh1    40: LOCALSRC=
                     41:
1.8       afresh1    42: tmpdir() {
                     43:        local _i=1 _dir
                     44:
1.50      afresh1    45:        # If we're not in the installer,
1.79      afresh1    46:        # we have mktemp and a more hostile environment.
1.50      afresh1    47:        if [ -x /usr/bin/mktemp ]; then
                     48:                _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44      afresh1    49:        else
1.50      afresh1    50:                until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44      afresh1    51:                    ((++_i < 10000)) || return 1
                     52:                done
                     53:        fi
1.50      afresh1    54:
1.8       afresh1    55:        echo "$_dir"
                     56: }
1.6       afresh1    57:
1.50      afresh1    58: fetch() {
1.92      afresh1    59:        local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
1.6       afresh1    60:
1.79      afresh1    61:        # If we're not in the installer,
                     62:        # we have su(1) and doas(1) is unlikely to be configured.
1.85      afresh1    63:        set -o monitor # make sure ftp gets its own process group
                     64:        (
1.101     afresh1    65:        flags=-VM
                     66:        "$VERBOSE" && flags=-vm
1.53      afresh1    67:        if [ -x /usr/bin/su ]; then
1.85      afresh1    68:                exec /usr/bin/su -s /bin/ksh "$_user" -c \
1.101     afresh1    69:                    "/usr/bin/ftp -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"
1.42      afresh1    70:        else
1.85      afresh1    71:                exec /usr/bin/doas -u "$_user" \
1.101     afresh1    72:                    /usr/bin/ftp -D 'Get/Verify' $flags -o- "$_src" > "$_dst"
1.42      afresh1    73:        fi
1.85      afresh1    74:        ) & _pid=$!
                     75:        set +o monitor
                     76:
1.98      afresh1    77:        trap "kill -TERM '-$_pid' 2>/dev/null; exit 1" EXIT INT QUIT ABRT TERM
1.85      afresh1    78:
                     79:        SECONDS=0
                     80:        _last=0
                     81:        while kill -0 -"$_pid" 2>/dev/null; do
                     82:                if [[ $SECONDS -gt 12 ]]; then
                     83:                        set -- $( ls -ln "$_dst" 2>/dev/null )
                     84:                        if [[ $_last -ne $5 ]]; then
                     85:                                _last=$5
                     86:                                SECONDS=0
                     87:                                sleep 1
                     88:                        else
                     89:                                kill -INT -"$_pid"
1.92      afresh1    90:                                _error=" (timed out)"
1.85      afresh1    91:                        fi
                     92:                else
                     93:                        sleep 1
                     94:                fi
                     95:        done
                     96:
                     97:        set +o errexit
                     98:        wait "$_pid"
                     99:        _exit=$?
                    100:        set -o errexit
                    101:
                    102:        trap "" EXIT INT QUIT ABRT TERM
1.6       afresh1   103:
1.50      afresh1   104:        if [ "$_exit" -ne 0 ]; then
1.69      afresh1   105:                rm -f "$_dst"
1.92      afresh1   106:                echo "Cannot fetch $_src$_error" >&2
1.50      afresh1   107:                return 1
                    108:        fi
1.6       afresh1   109: }
                    110:
1.50      afresh1   111: verify() {
                    112:        # On the installer we don't get sha256 -C, so fake it.
1.69      afresh1   113:        if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                    114:                echo "Checksum test for ${1##*/} failed." >&2
1.50      afresh1   115:                return 1
                    116:        fi
1.6       afresh1   117: }
                    118:
1.50      afresh1   119: devices_needing_firmware() {
1.90      afresh1   120:        local _d _m _line _dmesgtail _last='' _nl=$( echo )
1.1       afresh1   121:
1.50      afresh1   122:        # When we're not in the installer, the dmesg.boot can
                    123:        # contain multiple boots, so only look in the last one
1.89      afresh1   124:        _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
                    125:            grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
1.50      afresh1   126:
1.89      afresh1   127:        grep -v '^[[:space:]]*#' "$FWPATTERNS" |
                    128:            while read -r _d _m; do
                    129:                [ "$_d" = "$_last" ] && continue
1.90      afresh1   130:                [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                    131:                [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
1.83      afresh1   132:
1.89      afresh1   133:                if [[ $_dmesgtail = *$_m* ]]; then
                    134:                        echo "$_d"
                    135:                        _last="$_d"
                    136:                fi
                    137:            done
1.50      afresh1   138: }
1.14      afresh1   139:
1.50      afresh1   140: firmware_filename() {
1.56      afresh1   141:        local _f
                    142:        _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
                    143:        ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
                    144:        echo "$_f"
1.50      afresh1   145: }
1.7       afresh1   146:
1.57      afresh1   147: firmware_devicename() {
                    148:        local _d="${1##*/}"
                    149:        _d="${_d%-firmware-*}"
                    150:        echo "$_d"
                    151: }
                    152:
1.50      afresh1   153: installed_firmware() {
1.95      afresh1   154:        set +o noglob
1.50      afresh1   155:        for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
1.96      afresh1   156:                [ -e "$fw/+CONTENTS" ] || continue
1.50      afresh1   157:                echo "${fw##*/}"
                    158:        done
1.95      afresh1   159:        set -o noglob
1.50      afresh1   160: }
1.1       afresh1   161:
1.50      afresh1   162: add_firmware () {
1.74      afresh1   163:        local _f="${1##*/}"
                    164:        local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
1.101     afresh1   165:        local flags=-VM
                    166:        "$VERBOSE" && flags=-vm
                    167:        ftp -D "Install" "$flags" -o- "file:${1}" |
1.73      afresh1   168:                tar -s ",^\+,${_pkgdir}/+," \
1.69      afresh1   169:                    -s ",^firmware,${DESTDIR}/etc/firmware," \
                    170:                    -C / -zxphf - "+*" "firmware/*"
1.1       afresh1   171:
1.50      afresh1   172:        # TODO: Should we mark these so real fw_update can -Drepair?
1.73      afresh1   173:        ed -s "${_pkgdir}/+CONTENTS" <<EOL
1.50      afresh1   174: /^@comment pkgpath/ -1a
                    175: @option manual-installation
                    176: @option firmware
                    177: @comment install-script
                    178: .
                    179: w
                    180: EOL
                    181: }
1.22      afresh1   182:
1.50      afresh1   183: delete_firmware() {
1.51      afresh1   184:        local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22      afresh1   185:
1.50      afresh1   186:        # TODO: Check hash for files before deleting
1.101     afresh1   187:        "$VERBOSE" && echo "Uninstalling $_pkg"
1.51      afresh1   188:        _cwd="${_pkgdir}/$_pkg"
1.50      afresh1   189:
1.51      afresh1   190:        set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50      afresh1   191:
                    192:        while read -r c g; do
                    193:                case $c in
1.51      afresh1   194:                @cwd) _cwd="${DESTDIR}$g"
1.50      afresh1   195:                  ;;
                    196:                @*) continue
                    197:                  ;;
1.52      afresh1   198:                *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50      afresh1   199:                  ;;
                    200:                esac
                    201:        done < "${_pkgdir}/${_pkg}/+CONTENTS"
                    202:
                    203:        # We specifically rm -f here because not removing files/dirs
                    204:        # is probably not worth failing over.
                    205:        for _r in "${_remove[@]}" ; do
                    206:                if [ -d "$_r" ]; then
                    207:                        # Try hard not to actually remove recursively
                    208:                        # without rmdir on the install media.
1.95      afresh1   209:                        set +o noglob
1.50      afresh1   210:                        [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
1.95      afresh1   211:                        set -o noglob
1.50      afresh1   212:                else
                    213:                        rm -f "$_r"
1.22      afresh1   214:                fi
                    215:        done
1.50      afresh1   216: }
1.1       afresh1   217:
1.59      afresh1   218: usage() {
1.93      afresh1   219:        echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"
1.59      afresh1   220:        exit 2
                    221: }
                    222:
1.87      afresh1   223: OPT_D=
                    224: OPT_L=
1.100     afresh1   225: while getopts :DLv name
1.59      afresh1   226: do
                    227:        case "$name" in
1.87      afresh1   228:        D) OPT_D=true ;;
                    229:        L) OPT_L=true ;;
1.97      afresh1   230:        v) VERBOSE=true ;;
1.99      afresh1   231:        ?) echo "${0##*/}: unknown option -- -$OPTARG"; usage 2 ;;
1.59      afresh1   232:        esac
                    233: done
                    234: shift $((OPTIND - 1))
                    235:
1.87      afresh1   236: [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
                    237:
                    238: if [ "$OPT_D" ]; then
                    239:        # "Download only" means local dir and don't install
                    240:        INSTALL=false
                    241:        LOCALSRC=.
                    242: elif [ "$OPT_L" ]; then
                    243:        # "Local" means don't download, install from local dir
                    244:        DOWNLOAD=false
                    245:        LOCALSRC=.
                    246: else
1.102     afresh1   247:        LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
1.87      afresh1   248: fi
1.64      afresh1   249:
1.78      afresh1   250: CFILE="$LOCALSRC/$CFILE"
                    251:
1.104   ! afresh1   252: if "$INSTALL" && [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
1.94      afresh1   253:        echo "need root privileges" >&2
                    254:        exit 1
                    255: fi
                    256:
1.58      afresh1   257: set -A devices -- "$@"
                    258:
1.65      afresh1   259: if [ ! "${devices[*]:-}" ]; then
1.101     afresh1   260:        "$VERBOSE" && echo -n "Detecting firmware ..."
1.91      afresh1   261:        set -A devices -- $( devices_needing_firmware )
1.101     afresh1   262:        "$VERBOSE" &&
                    263:            { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
1.50      afresh1   264: fi
1.91      afresh1   265:
                    266: [ "${devices[*]:-}" ] || exit
1.50      afresh1   267:
1.71      afresh1   268: if "$DOWNLOAD"; then
1.64      afresh1   269:        fetch "$CFILE"
                    270:        ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                    271:            echo "Signature check of SHA256.sig failed" >&2 && exit 1
                    272: fi
1.50      afresh1   273:
1.103     afresh1   274: added=''
                    275: updated=''
1.70      afresh1   276: for f in "${devices[@]}"; do
                    277:        d="$( firmware_devicename "$f" )"
                    278:
1.58      afresh1   279:        if [ "$f" = "$d" ]; then
                    280:                f=$( firmware_filename "$d" || true )
                    281:                [ "$f" ] || continue
1.69      afresh1   282:                f="$LOCALSRC/$f"
1.76      afresh1   283:        elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70      afresh1   284:                echo "Cannot download local file $f" >&2
                    285:                exit 2
1.58      afresh1   286:        fi
                    287:
1.50      afresh1   288:        set -A installed -- $( installed_firmware "$d" )
                    289:
1.68      afresh1   290:        if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65      afresh1   291:                for i in "${installed[@]}"; do
1.58      afresh1   292:                        if [ "${f##*/}" = "$i.tgz" ]; then
1.101     afresh1   293:                                "$VERBOSE" && echo "$i already installed"
1.11      afresh1   294:                                continue 2
1.1       afresh1   295:                        fi
                    296:                done
1.50      afresh1   297:        fi
1.1       afresh1   298:
1.72      afresh1   299:        if [ -e "$f" ]; then
                    300:                if "$DOWNLOAD"; then
1.101     afresh1   301:                        "$VERBOSE" && echo "Verify existing ${f##*/}"
1.72      afresh1   302:                        verify "$f" || continue
                    303:                # else assume it was verified when downloaded
                    304:                fi
1.75      afresh1   305:        elif "$DOWNLOAD"; then
                    306:                fetch  "$f" || continue
                    307:                verify "$f" || continue
                    308:        elif "$INSTALL"; then
1.72      afresh1   309:                echo "Cannot install ${f##*/}, not found" >&2
                    310:                continue
1.58      afresh1   311:        fi
1.60      afresh1   312:
1.68      afresh1   313:        "$INSTALL" || continue
1.11      afresh1   314:
1.103     afresh1   315:        removed=false
1.65      afresh1   316:        if [ "${installed[*]:-}" ]; then
1.50      afresh1   317:                for i in "${installed[@]}"; do
                    318:                        delete_firmware "$i"
1.103     afresh1   319:                        removed=true
1.50      afresh1   320:                done
                    321:        fi
1.11      afresh1   322:
1.50      afresh1   323:        add_firmware "$f"
1.103     afresh1   324:
                    325:        if "$removed"; then
                    326:                [ "$updated" ] && updated="$updated,"
                    327:                updated="$updated$d"
                    328:        else
                    329:                [ "$added" ] && added="$added,"
                    330:                added="$added$d"
                    331:        fi
1.50      afresh1   332: done
1.1       afresh1   333:
1.103     afresh1   334: if ! $VERBOSE && { [ "$added" ] || [ "$updated" ]; }; then
                    335:        echo  "${0##*/}: $(
                    336:            [ "$added" ] && echo -n "added ${added}"
                    337:            [ "$added" ] && [ "$updated" ] && echo -n "; "
                    338:            [ "$updated" ] && echo -n "updated ${updated}"
                    339:        )"
                    340: fi

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>